package com.fxy.fms.putOut;

import android.annotation.SuppressLint;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.KeyEvent;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.elvishew.xlog.XLog;
import com.google.zxing.Result;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;
import com.fxy.baselibrary.base.BaseActivity;
import com.fxy.baselibrary.bean.BaseEventBusBean;
import com.fxy.baselibrary.interfaces.OnRxScanerListener;
import com.fxy.baselibrary.qrcode.ActivityScanerCode;
import com.fxy.baselibrary.util.JsonUtil;
import com.fxy.baselibrary.util.StringUtils;
import com.fxy.baselibrary.views.MarqueeTextView;
import com.fxy.R;
import com.fxy.bean.ActionBean;
import com.fxy.bean.ScanBean;
import com.fxy.constant.BaseConfig;
import com.fxy.constant.EventCode;
import com.fxy.fms.logic.ViewLogic;
import com.fxy.net.MyDialogCallback;
import com.fxy.net.Urls;
import com.fxy.view.FloatingImageView;

import org.json.JSONException;
import org.json.JSONObject;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;
import sto.android.app.StoJNI;
import sto.android.app.StoPdaKeyEvent;
import sto.android.app.StoTongJNI;

public class StorageAddMainActivity extends  BaseActivity implements StoJNI.ScanCallBack {
    /**
     * 列表适配器
     */
    Context mContext = this;
    @BindView(R.id.mt_outbound_number)
    MarqueeTextView mtOutboundNumber;

    //单号清除
    @BindView(R.id.ib_order_no_clear)
    ImageButton ibOrderNoClear;

    //单号
    @BindView(R.id.et_order_no)
    EditText etOrderNo;

    //单号
    @BindView(R.id.et_order_qty)
    EditText etOrderQty;


    //浮动按钮
    @BindView(R.id.iv_drag)
    FloatingImageView iv_drag;

    @BindView(R.id.ll_storage_details)
    LinearLayout llStorageDetails;

    //扫码扫码动作
    private ScanBean scanBean;

    protected String action;

    //订单信息对象
    private JSONObject outboundObject;

    //装柜信息
    private JSONObject storageObject;

    private JSONObject postParam = new JSONObject();

    private Unbinder unbinder;

    //订单号
    private String orderNumber;

    private String loadingQty;

    private ViewLogic viewLogic;

    @Override
    public int getContentViewResId() {
        return R.layout.activity_fms_storage_add;
    }

    @Override
    public boolean showToolBar() {
        return true;
    }

    @Override
    public boolean openEventBus() {
        return true;
    }

    @Override
    protected void getBundleExtras(Bundle bundle) {
        try {
            outboundObject = new JSONObject(bundle.getString("outbound_object"));
            postParam = new JSONObject(bundle.getString("post_param"));
            action = bundle.getString("action","storage");
        } catch (JSONException e) {
            XLog.e("接收数据解析："+e.getMessage());
            e.printStackTrace();
        }

    }
    //finish的返回监听
    //这里的requestCode参数，就是上面设置的 1 ，当跳转的页面返回的时候，通过这个加以判断
    //resultCode ,这个参数是在跳转的页面里面规定的，它也是一个int类型的标志
    //第三个参数包含了返回的值
    //如果不需要所跳转的页面返回值，也就不需要这个方法了
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
//        XLog.e("requestCode："+requestCode);
//        XLog.e("resultCode："+resultCode);
        if (requestCode == 200 && resultCode == 200)//之前提到的两个标志，在这里显示出了作用
        {
            String  opt_status    = data.getStringExtra("opt_status").toString();
            if (opt_status.equals("success")){
                clearData();
                getStorageInfo();
            }
        }else if (resultCode==0){


        }
    }


    /**
     * EventBus接收信息的方法，开启后才会调用(非粘性事件)
     *
     * @param event
     */
    @Override
    protected void EventBean(BaseEventBusBean event) {
//        XLog.e("----------接收返回--------------");
//        XLog.e("接收返回："+event.getEventCode());
        if (event != null && event.getEventCode() == EventCode.displacement_refresh){

        }
    }

    @Override
    public boolean isPlayMusic() {
        return true;
    }

    @Override
    protected void initView() {
        unbinder = ButterKnife.bind(this);
        viewLogic = new ViewLogic(llStorageDetails);
        setTitleName("装柜扫描");
        initEdit();
        initData();
        //监听浮动按钮
        iv_drag.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(!iv_drag.isDrag()){
                    ActivityScanerCode.setScanerListener(mScanerListener);
                    ActivityScanerCode.intent2Activity(mContext, BaseConfig.COMMON_SCANNER_ONLY);
                }
            }
        });

    }


    private void initData(){
        try {
            mtOutboundNumber.setText(outboundObject.getString("outbound_number"));
        } catch (JSONException e) {
            e.printStackTrace();
        }
        getStorageInfo();

    }

    public void getStorageInfo(){
        try {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("outbound_number",outboundObject.getString("outbound_number"));
            OkGo.<String>post(Urls.getServiceAddress(this) + Urls.FMS_GET_OUTBOUND_INFO).upJson(jsonObject)
                    .execute(new MyDialogCallback(this, true, true) {
                        @Override
                        public void onSuccess(Response<String> response) {
                            super.onSuccess(response);
                            try {
                                ActionBean bean = JsonUtil.getObject(response.body(), ActionBean.class);
                                if(bean.code == 1){
                                    JSONObject data = new JSONObject(bean.data);
                                    viewLogic.setOutbound(data,null);
                                }else{
                                    showWarningToast(bean.msg);
                                }
                            } catch (Exception e) {
                                showWarningToast("获取获取排舱解析错误:"+e.getMessage());
                                e.printStackTrace();
                                XLog.e("获取获取排舱解析错误",e.getMessage());
                            }
                        }
                    });
        }catch (Exception e){
            showWarningToast(e.getMessage());
            XLog.e("请求获取排舱信息错误:",e);
        }
    }






    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        //XLog.e("event:"+event.getKeyCode());
        if ((event.getKeyCode()==KeyEvent.KEYCODE_DPAD_CENTER || event.getKeyCode()==KeyEvent.KEYCODE_ENTER )  && event.getAction() == KeyEvent.ACTION_DOWN){
            //按确定键
            if(this.validate()){
                addStorage();
            }
        }
        return super.dispatchKeyEvent(event);
    }

    //监听按键
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        XLog.e("监听按键："+keyCode);XLog.e(event);
        if (scanBean.getIsBroadcast()==0 && StoTongJNI.getIns(mContext).getEventFuction(keyCode)  == StoPdaKeyEvent.KEYCODE_SCAN
                && event.getRepeatCount() == 0) {

            if (StoTongJNI.getIns(mContext).GetScannerIsScanning()) {
//
            } else {
                StoTongJNI.getIns(mContext).SetScannerStart();
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    @SuppressLint("HandlerLeak")
    Handler scanHandler = new Handler() {

        @Override
        public void handleMessage(Message msg) {
            // TODO Auto-generated method stub
            if (msg.obj != null) {

                String scanResult = msg.obj.toString().trim();
                if (!scanResult.isEmpty()){
                    setScanResult(scanResult);
                }
            }

        }

    };
    @Override
    public void onScanResults(String str) {
        Message msg = new Message();
        msg.obj = str;
        scanHandler.sendMessage(msg);


    }


    @Override
    public void onScanResults(String str, int type) {

    }
    /**
     * 定义广播接受
     */
    BroadcastReceiver mReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String scanResult = intent.getStringExtra(scanBean.getDataName());
            if (scanResult==null){return; }
            String scanStatus = "";
            if (!scanBean.getStatusName().isEmpty()){
                scanStatus = intent.getStringExtra(scanBean.getStatusName());
            }else{
                scanStatus = scanResult.isEmpty()? "" : "ok"; //有值 默认是扫码成功;
            }

            //新大陆(MT65,MT90) 需要手动关闭
            if (!scanBean.getActionStop().isEmpty()){
                Intent stopIntent = new Intent(scanBean.getActionStop());
                mContext.sendBroadcast(stopIntent);
            }

            if ("ok".equals(scanStatus)){
                setScanResult(scanResult);
            }else{
                showErrorToast(getString(R.string.scan_failed));
            }
        }
    };

    /**
     * 注册广播
     */
    private void initReceiver(){

        try {

            String scanStr = getScanSetting();
            scanBean = JsonUtil.getObject(scanStr, ScanBean.class);
            Integer is_broadcast = scanBean.getIsBroadcast();//是否广播

            if (is_broadcast ==1){
                IntentFilter mFilter = new IntentFilter(scanBean.getAction());
                this.registerReceiver(mReceiver, mFilter);
            }else{
                //不广播进行处理 jni模式
                String pdaBrand = StoTongJNI.getmPdaBrand();
                if (!pdaBrand.isEmpty()){
                    StoTongJNI.getIns(this).setmScanCB(this);
                    StoTongJNI.getIns(this).SetScannerOn();
                }
            }


        }catch (Exception e) {
            showErrorToast("获取扫码配置失败"+e.getMessage());
            XLog.e("获取扫码配置失败:" + e.getMessage());
        }
    }

    private void initEdit() {

        //
        etOrderNo.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                if (actionId == EditorInfo.IME_ACTION_DONE) {
                    String orderNo = etOrderNo.getText().toString().trim();
                    if (StringUtils.isEmpty(orderNo)) {
                        setEditTextFocused(v,true);
                        showWarningToast(v.getHint().toString());
                        return false;
                    }
                    checkOrder();//获取订单信息
                    return false;
                }
                return false;
            }
        });
        etOrderNo.addTextChangedListener(new TextWatcher() {
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                orderNumber = s.toString().trim();
                if (s.length() > 0 ) {
                    if (etOrderNo.isEnabled()){
                        ibOrderNoClear.setVisibility(View.VISIBLE);
                    }
                    setEditTextNormal(etOrderNo,true);
                } else {
                    ibOrderNoClear.setVisibility(View.INVISIBLE);
                    setEditTextFocused(etOrderNo,true);
                }
            }

            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
            }

            public void afterTextChanged(Editable s) {

            }
        });
        ibOrderNoClear.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                etOrderNo.requestFocus();
                etOrderNo.getText().clear();
            }
        });
    }

    private OnRxScanerListener mScanerListener = new OnRxScanerListener() {
        @Override
        public void onSuccess(String type, Result result) {
            String scanResult = result.getText();
            switch (type){
                case BaseConfig.COMMON_SCANNER_ONLY:
                    setScanResult(scanResult);

                    break;
            }
        }
        @Override
        public void onFail(String type, String message) {

        }
    };

    //把扫描结果赋值
    private void setScanResult(String scanResult){
        //获取焦点的view对象
        View view=getWindow().getDecorView().findFocus();
        //如果是EditText
        if(view instanceof EditText)
        {
            ((EditText) view).setText(scanResult);

            switch (view.getId()) {
                case R.id.et_order_no:
                    checkOrder();
                    break;
                default:
            }


        }
    }


    private void checkOrder(){
        final String orderNo = etOrderNo.getText().toString().trim();
        if (orderNo.isEmpty()){
            return;
        }
        try {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("order_number",orderNo);
            jsonObject.put("outbound_number",outboundObject.getString("outbound_number"));
            jsonObject.put("action",action);
            if (!checkRepeat(Urls.FMS_OUTBOUND_CHECK_ORDER+(jsonObject.toString()))){
                Toast.makeText(this, getString(R.string.error_data_processed), Toast.LENGTH_LONG).show();
                return;
            }

            OkGo.<String>post(Urls.getServiceAddress(this) + Urls.FMS_OUTBOUND_CHECK_ORDER).upJson(jsonObject)
                    .execute(new MyDialogCallback(this, true, true) {
                        @Override
                        public void onSuccess(Response<String> response) {
                            super.onSuccess(response);
                            try {
                                ActionBean bean = JsonUtil.getObject(response.body(), ActionBean.class);
                                if(bean.code == 1){
                                    storageObject = new JSONObject(bean.data);
                                    //设置订单信息
                                    etOrderQty.requestFocus();

                                    //更新数据
                                    getStorageInfo();
                                }else{
                                    storageObject = null;
                                    showWarningToast(bean.msg);
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                                showEmptyView("出库检查订单信息解析错误:"+e.getMessage());
                                XLog.e("出库检查订单信息解析错误",e.getMessage());
                            }
                        }
                    });
        }catch (Exception e){
            storageObject = null;
            XLog.e("出库检查订单信息错误:",e);
        }
    }


    private void addStorage() {

        //校验数据
        if (!validate()){
            return;
        }
        if (storageObject==null){
            checkOrder();
            return;
        }
        orderNumber = etOrderNo.getText().toString().trim();
        loadingQty = etOrderQty.getText().toString().trim();

        try {
            postParam.put("loading_qty",loadingQty);
            postParam.put("order_number",orderNumber);
            if (!checkRepeat(Urls.FMS_ADD_STORAGE+(postParam.toString()))){return;}
            OkGo.<String>post(Urls.getServiceAddress(this) + Urls.FMS_ADD_STORAGE).upJson(postParam)
                    .execute(new MyDialogCallback(this, true, true) {
                        @Override
                        public void onSuccess(Response<String> response) {
                            super.onSuccess(response);
                            try {
                                ActionBean bean = JsonUtil.getObject(response.body(), ActionBean.class);
                                if(bean.code == 1){
                                    showSuccessToast(bean.msg);
                                    clearData();
                                    getStorageInfo();
                                }else{

                                    showWarningToast(bean.msg);
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                                XLog.e("添加理货数据结果返回错误",e.getMessage());
                            }
                        }
                    });
        } catch (JSONException e) {
            showEmptyView("数据组装失败:"+e.getMessage());
            e.printStackTrace();
        }


    }

    /*
     * 校验必录
     */
    private boolean validate(){
        if(!checkNull(etOrderNo)){
            setEditTextFocused(etOrderNo,true);
            showWarningToast(getString(R.string.hint_please_scan_no));
            return false;
        }
        if(!checkNull(etOrderQty)){
            setEditTextFocused(etOrderQty,true);
            showWarningToast(etOrderQty.getHint().toString());
            return false;
        }
        return true;
    }


    //清除订单信息
    private void clearData() {
        etOrderNo.setText("");
        etOrderQty.setText("");
        etOrderNo.requestFocus();

    }

    @OnClick({R.id.btn_add_loader,R.id.btn_finish,R.id.tv_not_look,R.id.tv_has_look,R.id.ima_or_code})
    public void onViewClicked(View view) {
        Bundle bundle = new Bundle();
        switch (view.getId()) {
            case R.id.btn_add_loader:
                addStorage();;

                break;
            case R.id.btn_finish:
                bundle.putString("outbound_object",outboundObject.toString());
                bundle.putString("action",action);
                intentPageResult(this, StorageFinishMainActivity.class, bundle,200);
                break;
            case R.id.ima_or_code:
                if(etOrderNo.isEnabled()){
                    etOrderNo.requestFocus();
                    ActivityScanerCode.setScanerListener(mScanerListener);
                    ActivityScanerCode.intent2Activity(mContext, BaseConfig.COMMON_SCANNER_ONLY);
                }
                break;
            case R.id.tv_not_look:
                toChecklist(10);
                break;
            case R.id.tv_has_look:
                toChecklist(20);
                break;

            default:
                break;
        }
    }

    private void toChecklist(int status){
        Bundle bundle = new Bundle();
        try {
            JSONObject paramObject = new JSONObject();
            paramObject.put("outbound_number",outboundObject.getString("outbound_number"));
            paramObject.put("status",status);
            bundle.putString("param_object",paramObject.toString());
            bundle.putString("action",action);
            intentPageResult(this, StorageChecklistMainActivity.class, bundle,200);
        } catch (JSONException e) {
            XLog.e("调整参数错误"+e.getMessage());
            e.printStackTrace();
        }
    }

    @Override
    protected void onDestroy() {
        unbinder.unbind();


        super.onDestroy();
    }
    @Override
    protected void onResume() {
        super.onResume();
        initReceiver();
    }
    @Override
    protected void onPause() {
        super.onPause();
        //销毁在onResume()方法中的广播
        try {
            //停止扫描
            Integer is_broadcast = scanBean.getIsBroadcast();//是否广播
            if (is_broadcast==0){
                StoTongJNI.getIns(mContext).SetScannerStop();
                StoTongJNI.getIns(mContext).SetScannerOff();
            }else{
                unregisterReceiver(mReceiver);
            }
        }catch (Exception e){
            XLog.e("销毁广播失败：",e.getMessage());
        }
    }


}
