package com.fxy.putOut;

import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.KeyEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.EditorInfo;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.RequiresApi;

import com.chad.library.adapter.base.BaseQuickAdapter;
import com.chad.library.adapter.base.BaseViewHolder;
import com.elvishew.xlog.XLog;
import com.fxy.R;
import com.fxy.baselibrary.base.BaseActivity;
import com.fxy.baselibrary.bean.BaseEventBusBean;
import com.fxy.baselibrary.interfaces.OnRxScanerListener;
import com.fxy.baselibrary.qrcode.ActivityScanerCode;
import com.fxy.baselibrary.util.JsonUtil;
import com.fxy.baselibrary.util.StringUtils;
import com.fxy.baselibrary.views.MarqueeTextView;
import com.fxy.bean.ActionBean;
import com.fxy.bean.ScanBean;
import com.fxy.constant.BaseConfig;
import com.fxy.constant.EventCode;
import com.fxy.constant.SPCache;
import com.fxy.net.MyDialogCallback;
import com.fxy.net.Urls;
import com.fxy.view.FloatingImageView;
import com.google.zxing.Result;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import butterknife.Unbinder;
import sto.android.app.StoJNI;
import sto.android.app.StoPdaKeyEvent;
import sto.android.app.StoTongJNI;

public class DeliveryGoodsMainActivity extends  BaseActivity implements StoJNI.ScanCallBack {
    /**
     * 列表适配器
     */
    Context mContext = this;
    //单号
    @BindView(R.id.et_order_no)
    EditText etOrderNo;

    //单号
    @BindView(R.id.et_container_code)
    EditText etContainerCode;

    @BindView(R.id.tv_total_qty)
    TextView tvTotalQty;
    @BindView(R.id.tv_wait_scan_qty)
    TextView tvWaitScanQty;
    @BindView(R.id.tv_scan_qty)
    TextView tvScanQty;


    //托盘组件
    @BindView(R.id.ll_container)
    LinearLayout llContainer;



    @BindView(R.id.recyclerview)
    RecyclerView recyclerView;

    //浮动按钮
    @BindView(R.id.iv_drag)
    FloatingImageView iv_drag;

    private View notDataView;   //没有数据显示页
    private View errorView;     //错误显示页
    private View emptyView;     //空显示页
    /**
     * 列表适配器
     */
    private FinishWorkAdapter mAdapter;

    //扫码扫码动作
    private ScanBean scanBean;




    private Unbinder unbinder;

    //是否弹窗确认
    private int is_confirm = 0;

    //托盘数据
    private List<JSONObject> deliveryDataList = new ArrayList<>()   ;

    private JSONObject outboundObject;

    //托盘对象
    private JSONObject outboundInfo = null;

    @Override
    public int getContentViewResId() {
        return R.layout.activity_fxy_delivery_goods;
    }

    @Override
    public boolean showToolBar() {
        return true;
    }

    @Override
    public boolean openEventBus() {
        return true;
    }

    @Override
    protected void getBundleExtras(Bundle bundle) {

    }
    //finish的返回监听
    //这里的requestCode参数，就是上面设置的 1 ，当跳转的页面返回的时候，通过这个加以判断
    //resultCode ,这个参数是在跳转的页面里面规定的，它也是一个int类型的标志
    //第三个参数包含了返回的值
    //如果不需要所跳转的页面返回值，也就不需要这个方法了
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
//        XLog.e("requestCode："+requestCode);
//        XLog.e("resultCode："+resultCode);
        if (requestCode == 200 && resultCode == 200)//之前提到的两个标志，在这里显示出了作用
        {
        }else if (resultCode==0){
        }
    }


    /**
     * EventBus接收信息的方法，开启后才会调用(非粘性事件)
     *
     * @param event
     */
    @Override
    protected void EventBean(BaseEventBusBean event) {
//        XLog.e("----------接收返回--------------");
//        XLog.e("接收返回："+event.getEventCode());
        if (event != null && event.getEventCode() == EventCode.displacement_refresh){

        }
    }

    @Override
    public boolean isPlayMusic() {
        return true;
    }

    @Override
    protected void initView() {
        unbinder = ButterKnife.bind(this);
        setTitleName(getString(R.string.str_cargo_storage));

        initAdapter();
        initData();
        initEdit();
        //监听浮动按钮
        iv_drag.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(!iv_drag.isDrag()){
                    ActivityScanerCode.setScanerListener(mScanerListener);
                    ActivityScanerCode.intent2Activity(mContext, BaseConfig.COMMON_SCANNER_ONLY);
                }
            }
        });
    }


    private void initData(){

    }







    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        //XLog.e("event:"+event.getKeyCode());
        if ((event.getKeyCode()==KeyEvent.KEYCODE_DPAD_CENTER )  && event.getAction() == KeyEvent.ACTION_DOWN){
            //按确定键
            if(this.validate()){
                //doPutIn();
            }
        }
        return super.dispatchKeyEvent(event);
    }

    //监听按键
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        //XLog.e("监听按键："+keyCode);XLog.e(event);
        if (scanBean.getIsBroadcast()==0 && StoTongJNI.getIns(mContext).getEventFuction(keyCode)  == StoPdaKeyEvent.KEYCODE_SCAN
                && event.getRepeatCount() == 0) {

            if (StoTongJNI.getIns(mContext).GetScannerIsScanning()) {
//
            } else {
                StoTongJNI.getIns(mContext).SetScannerStart();
            }
        }
        return super.onKeyDown(keyCode, event);
    }

    @SuppressLint("HandlerLeak")
    Handler scanHandler = new Handler() {

        @Override
        public void handleMessage(Message msg) {
            // TODO Auto-generated method stub
            if (msg.obj != null) {

                String scanResult = msg.obj.toString().trim();
                if (!scanResult.isEmpty()){
                    setScanResult(scanResult);
                }
            }

        }

    };
    @Override
    public void onScanResults(String str) {
        Message msg = new Message();
        msg.obj = str;
        scanHandler.sendMessage(msg);


    }


    @Override
    public void onScanResults(String str, int type) {

    }
    /**
     * 定义广播接受
     */
    BroadcastReceiver mReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String scanResult = intent.getStringExtra(scanBean.getDataName());
            if (scanResult==null){return; }
            String scanStatus = "";
            if (!scanBean.getStatusName().isEmpty()){
                scanStatus = intent.getStringExtra(scanBean.getStatusName());
            }else{
                scanStatus = scanResult.isEmpty()? "" : "ok"; //有值 默认是扫码成功;
            }

            //新大陆(MT65,MT90) 需要手动关闭
            if (!scanBean.getActionStop().isEmpty()){
                Intent stopIntent = new Intent(scanBean.getActionStop());
                mContext.sendBroadcast(stopIntent);
            }

            if ("ok".equals(scanStatus)){
                setScanResult(scanResult);
            }else{
                showErrorToast(getString(R.string.scan_failed));
            }
        }
    };

    /**
     * 注册广播
     */
    private void initReceiver(){

        try {

            String scanStr = getScanSetting();
            scanBean = JsonUtil.getObject(scanStr, ScanBean.class);
            Integer is_broadcast = scanBean.getIsBroadcast();//是否广播

            if (is_broadcast ==1){
                IntentFilter mFilter = new IntentFilter(scanBean.getAction());
                this.registerReceiver(mReceiver, mFilter);
            }else{
                //不广播进行处理 jni模式
                String pdaBrand = StoTongJNI.getmPdaBrand();
                if (!pdaBrand.isEmpty()){
                    StoTongJNI.getIns(this).setmScanCB(this);
                    StoTongJNI.getIns(this).SetScannerOn();
                }
            }


        }catch (Exception e) {
            showErrorToast("获取扫码配置失败"+e.getMessage());
            XLog.e("获取扫码配置失败:" + e.getMessage());
        }
    }


    //统一按钮回调
    public void callbackEditor(View v){
        switch (v.getId()) {
            case R.id.et_order_no:
                getOutboundInfo();
                break;
            case R.id.et_container_code:
                addOutbound();
                break;
            default:
        }
    }





    private void initEdit() {
        List<EditText> list = new ArrayList<>();
        list.add(etOrderNo);
        list.add(etContainerCode);
        unifyEdit(list);
    }

    private OnRxScanerListener mScanerListener = new OnRxScanerListener() {
        @Override
        public void onSuccess(String type, Result result) {
            String scanResult = result.getText();
            switch (type){
                case BaseConfig.COMMON_SCANNER_ONLY:
                    setScanResult(scanResult);

                    break;
            }
        }
        @Override
        public void onFail(String type, String message) {

        }
    };

    //把扫描结果赋值
    private void setScanResult(String scanResult){
        //获取焦点的view对象
        View view=getWindow().getDecorView().findFocus();
        //如果是EditText
        if(view instanceof EditText)
        {
            ((EditText) view).setText(scanResult);
            //执行回调
            callbackEditor(view);
        }
    }

    /**
     * 获取打托信息
     */
    private void getOutboundInfo(){
        final String outbound_number = etOrderNo.getText().toString().trim();
        if (outbound_number.isEmpty()){
            setEditTextFocused(etOrderNo,true);
            showWarningToast(etOrderNo.getHint().toString());
            return ;
        }
        try {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("outbound_number",outbound_number);
            if (!checkRepeat(Urls.FXY_GET_OUTBOUND+(jsonObject.toString()))){
                Toast.makeText(this, getString(R.string.error_data_processed), Toast.LENGTH_LONG).show();
                return;
            }

            OkGo.<String>post(Urls.getServiceAddress(this) + Urls.FXY_GET_OUTBOUND).upJson(jsonObject)
                    .execute(new MyDialogCallback(this, true, true) {
                        @Override
                        public void onSuccess(Response<String> response) {
                            super.onSuccess(response);
                            try {
                                ActionBean bean = JsonUtil.getObject(response.body(), ActionBean.class);

                                outboundObject = new JSONObject();
                                if (bean.data!=null && !bean.data.isEmpty() && !bean.data.equals("[]")){
                                    outboundObject = new JSONObject(bean.data);
                                }


                                if(bean.code == 1){
                                    setPageViewData(outboundObject);
                                    etContainerCode.setEnabled(true);
                                    etContainerCode.requestFocus();

                                }else{
                                    outboundObject = null;
                                    showWarningToast(bean.msg);
                                    etOrderNo.requestFocus();
                                    etOrderNo.selectAll();
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                                showEmptyView("托盘信息解析错误:"+e.getMessage());
                                XLog.e("获取托盘信息解析错误",e.getMessage());
                            }
                        }
                    });
        }catch (Exception e){
            outboundInfo = null;
            XLog.e("请求托盘信息错误:"+e.getMessage(),e);
        }
    }

    /**
     * 关闭托盘
     */
    private void finishLoad(){
        final String outbound_number = etOrderNo.getText().toString().trim();
        if (outbound_number.isEmpty()){
            setEditTextFocused(etOrderNo,true);
            showWarningToast(etOrderNo.getHint().toString());
            return;
        }
        try {
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("outbound_number",outbound_number);

            if (is_confirm>0){
                jsonObject.put("is_confirm",is_confirm);
            }

            if (!checkRepeat(Urls.FMS_FINISH_LOAD+(jsonObject.toString()))){
                Toast.makeText(this, getString(R.string.error_data_processed), Toast.LENGTH_LONG).show();
                return;
            }

            OkGo.<String>post(Urls.getServiceAddress(this) + Urls.FMS_FINISH_LOAD).upJson(jsonObject)
                    .execute(new MyDialogCallback(this, true, true) {
                        @Override
                        public void onSuccess(Response<String> response) {
                            super.onSuccess(response);
                            try {
                                ActionBean bean = JsonUtil.getObject(response.body(), ActionBean.class);
                                etContainerCode.setEnabled(false);
                                clearData();


                                if(bean.code == 1){
                                    tvScanQty.setText("0");
                                    tvTotalQty.setText("0");
                                    tvWaitScanQty.setText("0");
                                    deliveryDataList.clear();
                                    mAdapter.setNewData(deliveryDataList);
                                    mAdapter.notifyDataSetChanged();
                                    etOrderNo.setText("");
                                    etOrderNo.requestFocus();

                                   showSuccessToast(bean.msg);
                                }else{

                                    JSONObject result = new JSONObject();
                                    if (bean.data!=null && !bean.data.isEmpty() && !bean.data.equals("[]")){
                                        result = new JSONObject(bean.data);
                                    }

                                    if (result.has("is_confirm") && result.getInt("is_confirm")>0){
                                        new AlertDialog.Builder(mContext)
                                                .setTitle(R.string.dl_hint)
                                                .setMessage(bean.msg)
                                                .setNegativeButton(R.string.str_submit, new DialogInterface.OnClickListener() {
                                                    @RequiresApi(api = Build.VERSION_CODES.KITKAT)
                                                    @Override
                                                    public void onClick(DialogInterface dialogInterface, int i) {
                                                        is_confirm  = 1;
                                                        finishLoad();
                                                    }
                                                }).setPositiveButton(R.string.str_cancel, new DialogInterface.OnClickListener() {
                                            @Override
                                            public void onClick(DialogInterface dialogInterface, int i) {
                                                //取消不做操作

                                            }
                                        }).show();
                                    }else {
                                        showWarningToast(bean.msg);
                                    }

                                }


                            } catch (Exception e) {
                                e.printStackTrace();
                                showEmptyView("关闭完成装柜解析错误:"+e.getMessage());
                                XLog.e("关完成装柜解析错误",e.getMessage());
                            }
                        }
                    });
        }catch (Exception e){
            outboundInfo = null;
            XLog.e("完成装柜错误:"+e.getMessage(),e);
        }
    }

    private void addOutbound() {
        //校验数据
        if (!validate()){
            return;
        }

        try {
            String pallet_code = etContainerCode.getText().toString().trim();
            final String outbound_number = etOrderNo.getText().toString().trim();
            JSONObject param = new JSONObject();
            param.put("pallet_code",pallet_code);
            param.put("outbound_number",outbound_number);




            if (!checkRepeat(Urls.FXY_ADD_OUTBOUND+(param.toString()))){return;}

            OkGo.<String>post(Urls.getServiceAddress(this) + Urls.FXY_ADD_OUTBOUND)
                    .upJson(param)
                    .execute(new MyDialogCallback(this, true, true) {
                        @Override
                        public void onSuccess(Response<String> response) {
                            super.onSuccess(response);
                            try {
                                ActionBean bean = JsonUtil.getObject(response.body(), ActionBean.class);

                                JSONObject result = new JSONObject();
                                if (bean.data!=null && !bean.data.isEmpty() && !bean.data.equals("[]")){
                                    result = new JSONObject(bean.data);
                                }

                                if(bean.code == 1){
                                    showSuccessToast(bean.msg);
                                    clearData();
                                    setPageViewData(result);

                                }else{

                                    if (result.has("is_confirm") && result.getInt("is_confirm")>0){
                                        new AlertDialog.Builder(mContext)
                                                .setTitle(R.string.dl_hint)
                                                .setMessage(bean.msg)
                                                .setNegativeButton(R.string.str_submit, new DialogInterface.OnClickListener() {
                                                    @RequiresApi(api = Build.VERSION_CODES.KITKAT)
                                                    @Override
                                                    public void onClick(DialogInterface dialogInterface, int i) {
                                                        is_confirm  = 1;
                                                    }
                                                }).setPositiveButton(R.string.str_cancel, new DialogInterface.OnClickListener() {
                                            @Override
                                            public void onClick(DialogInterface dialogInterface, int i) {
                                                //取消不做操作

                                            }
                                        }).show();
                                    }else {
                                        showWarningToast(bean.msg);
                                    }

                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                                XLog.e("请求出库返回错误",e.getMessage());
                            }
                        }
                    });
        } catch (JSONException e) {
            showEmptyView("请求出库失败:"+e.getMessage());
            e.printStackTrace();
        }


    }

    /*
     * 校验必录
     */
    private boolean validate(){
        if(!checkNull(etOrderNo)){
            setEditTextFocused(etOrderNo,true);
            showWarningToast(etOrderNo.getHint().toString());
            return false;
        }
        if(!checkNull(etContainerCode)){
            setEditTextFocused(etContainerCode,true);
            showWarningToast(etContainerCode.getHint().toString());
            return false;
        }
        return true;
    }

    private class FinishWorkAdapter extends BaseQuickAdapter<JSONObject, BaseViewHolder>{
        public FinishWorkAdapter(List<JSONObject> data){
            super(R.layout.item_putin_scan, data);
        }


        @Override
        protected void convert(BaseViewHolder helper, JSONObject item) {
            helper.addOnClickListener(R.id.ib_clear);//定义setOnItemChildClickListener 事件点击
            try {
                String number    = item.has("pallet_code")?item.getString("pallet_code"):"";
                helper.setText(R.id.tv_number,number);
            } catch (Exception e) {
                XLog.e("列表赋值错误",e);
                e.printStackTrace();
            }
        }
    }
    private void initAdapter(){
        emptyView = this.getLayoutInflater().inflate(R.layout.pager_empty, (ViewGroup) recyclerView.getParent(), false);
        errorView = this.getLayoutInflater().inflate(R.layout.pager_error, (ViewGroup) recyclerView.getParent(), false);
        notDataView = emptyView;

        mAdapter  = new FinishWorkAdapter(deliveryDataList);
        mAdapter.setEmptyView(emptyView);
        mAdapter.openLoadAnimation(BaseQuickAdapter.SCALEIN);
        recyclerView.setLayoutManager(new LinearLayoutManager(this));
        recyclerView.setAdapter(mAdapter);

        mAdapter.setOnItemChildClickListener(new BaseQuickAdapter.OnItemChildClickListener() {
            @Override
            public void onItemChildClick(BaseQuickAdapter adapter, View view, int position) {
                final int finalPosition = position;
                new AlertDialog.Builder(mContext)
                        .setTitle(R.string.dl_hint)
                        .setMessage("确定要删除？")
                        .setNegativeButton(R.string.str_submit, new DialogInterface.OnClickListener() {
                            @RequiresApi(api = Build.VERSION_CODES.KITKAT)
                            @Override
                            public void onClick(DialogInterface dialogInterface, int i) {
                                delOutbound(finalPosition);
                            }
                        }).setPositiveButton(R.string.str_cancel, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {
                        //取消不做操作

                    }
                }).show();


            }
        });

    }

    private void delOutbound(int position){
        try {
            if (deliveryDataList==null || deliveryDataList.size()==0){
                showWarningToast("已删除");
                return;
            }
            JSONObject itemObject = deliveryDataList.get(position);
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("outbound_number",itemObject.getString("outbound_number"));
            jsonObject.put("pallet_code",itemObject.getString("pallet_code"));
            jsonObject.put("is_move_out",1);
            if (!checkRepeat(Urls.FXY_DEL_OUTBOUND+(jsonObject.toString()))){
                Toast.makeText(mContext, getString(R.string.error_data_processed), Toast.LENGTH_LONG).show();
                return;
            }

            OkGo.<String>post(Urls.getServiceAddress(mContext) + Urls.FXY_DEL_OUTBOUND).upJson(jsonObject)
                    .execute(new MyDialogCallback(mContext, true, true) {
                        @Override
                        public void onSuccess(Response<String> response) {
                            super.onSuccess(response);
                            try {
                                ActionBean bean = JsonUtil.getObject(response.body(), ActionBean.class);

                                JSONObject result = new JSONObject();
                                if (bean.data!=null && !bean.data.isEmpty() && !bean.data.equals("[]")){
                                    result = new JSONObject(bean.data);
                                }

                                if(bean.code == 1){
                                    setPageViewData(result);
                                }else{
                                    showWarningToast(bean.msg);
                                }
                            } catch (Exception e) {
                                e.printStackTrace();
                                showEmptyView("托盘信息解析错误:"+e.getMessage());
                                XLog.e("删除出库解析错误",e.getMessage());
                            }
                        }
                    });
        }catch (Exception e){
            outboundInfo = null;
            XLog.e("删除出库错误:"+e.getMessage(),e);
        }
    }

    /**
     * 设置页面数据
     * @param jsonObject
     */

    private void setPageViewData(JSONObject jsonObject){
        try {
            int no_scan_qty = 0;
            int total_pallet_qty = 0;
            int has_scan_qty = 0;
            deliveryDataList.clear();
            if (jsonObject.has("no_scan_qty")){
                no_scan_qty = jsonObject.getInt("no_scan_qty");
            }
            if (jsonObject.has("total_pallet_qty")){
                total_pallet_qty = jsonObject.getInt("total_pallet_qty");
            }

            if (jsonObject.has("has_scan_qty")){
                has_scan_qty = jsonObject.getInt("has_scan_qty");
            }


            tvWaitScanQty.setText(String.valueOf(no_scan_qty));
            tvTotalQty.setText(String.valueOf(total_pallet_qty));
            tvScanQty.setText(String.valueOf(has_scan_qty));

            if (jsonObject.has("list")){
                String listStr = jsonObject.getString("list");
                if ( !listStr.isEmpty()){
                    JSONArray jsonArray = new JSONArray(listStr);
                    for (int i = 0;i < jsonArray.length(); i++){
                        JSONObject tallyObject = jsonArray.getJSONObject(i);
                        deliveryDataList.add(tallyObject);
                    }
                    mAdapter.setNewData(deliveryDataList);
                    mAdapter.notifyDataSetChanged();
                }else{
                    mAdapter.setNewData(deliveryDataList);
                    mAdapter.notifyDataSetChanged();
                }
            }
        }catch (JSONException e) {
            XLog.e("获取出库缓存数据错误",e);
            e.printStackTrace();
        }

    }


    private void setShow(){

    }
    //清除订单信息
    private void clearData() {
        etContainerCode.setText("");
        is_confirm  = 0;
        etContainerCode.requestFocus();
        setEditTextNormal(etContainerCode,true);
        setEditTextNormal(etOrderNo,true);
    }

    @OnClick({R.id.btn_confirm})
    public void onViewClicked(View view) {
        Bundle bundle = new Bundle();
        switch (view.getId()) {
            case R.id.btn_confirm:
                finishLoad();
                break;
            default:
                break;
        }
    }

    /**
     * 统一设置Edit监听
     * @param  list
     */
    public void unifyEdit(List<EditText> list){
        for (int i=0;i<list.size();i++){
            EditText editText = list.get(i);

            LinearLayout linearLayout = (LinearLayout)editText.getParent();
            ImageButton imageButton = getChildImageButton(linearLayout);

            //监听扫描
            ImageView imageView = linearLayout.findViewById(R.id.ima_or_code);
            imageView.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    LinearLayout linearLayout = (LinearLayout)v.getParent();
                    for( int i = 0; i < linearLayout.getChildCount(); i++ ){
                        if( linearLayout.getChildAt(i) instanceof EditText ){
                            ((EditText)linearLayout.getChildAt(i)).requestFocus();
                            break;
                        }
                    }
                    ActivityScanerCode.setScanerListener(mScanerListener);
                    ActivityScanerCode.intent2Activity(mContext, BaseConfig.COMMON_SCANNER_ONLY);
                }
            });


            //监听按确定
            editText.setOnEditorActionListener(new TextView.OnEditorActionListener() {
                @Override
                public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                    //XLog.e("actionId："+actionId);
                    if (actionId == EditorInfo.IME_ACTION_SEND || actionId == EditorInfo.IME_ACTION_DONE  ) {
                        if (v.getText().toString().trim().isEmpty()) {
                            setEditTextFocused(v,true);
                            showWarningToast(v.getHint().toString());
                            return false;
                        }else{
                            setEditTextNormal(v,true);
                        }

                        callbackEditor(v);

                        return false;
                    }
                    return false;
                }
            });
            editText.addTextChangedListener(new TextWatcher() {
                public void onTextChanged(CharSequence s, int start, int before, int count) {
                    EditText currentEditText = null;
                    ImageButton currentImage = null;
                    //获取焦点的view对象
                    View view=getWindow().getDecorView().findFocus();
                    //如果是EditText
                    if(view instanceof EditText){
                        currentEditText = (EditText) view;
                        currentImage = getChildImageButton((LinearLayout)currentEditText.getParent());
                    }

                    if (s.length() > 0  ) {

                        if (currentImage !=null ){
                            currentImage.setVisibility(View.VISIBLE);
                        }
                        if (currentEditText!=null){
                            setEditTextNormal(currentEditText,true);
                        }

                    } else {
                        if (currentImage !=null ){
                            currentImage.setVisibility(View.INVISIBLE);
                        }
                        if (currentEditText!=null){
                            setEditTextFocused(currentEditText,true);
                        }
                    }
                }

                public void beforeTextChanged(CharSequence s, int start, int count, int after) {
                }

                public void afterTextChanged(Editable s) {

                }
            });

            if (imageButton !=null ){
                unifyClearEdit(imageButton);
            }
        }
    }


    @Override
    protected void onDestroy() {
        unbinder.unbind();


        super.onDestroy();
    }
    @Override
    protected void onResume() {
        super.onResume();
        initReceiver();
    }
    @Override
    protected void onPause() {
        super.onPause();
        //销毁在onResume()方法中的广播
        try {
            //停止扫描
            Integer is_broadcast = scanBean.getIsBroadcast();//是否广播
            if (is_broadcast==0){
                StoTongJNI.getIns(mContext).SetScannerStop();
                StoTongJNI.getIns(mContext).SetScannerOff();
            }else{
                unregisterReceiver(mReceiver);
            }
        }catch (Exception e){
            XLog.e("销毁广播失败：",e.getMessage());
        }
    }


}
